#include "client/rendering/Framebuffers.h"

Framebuffers::Framebuffers(const WindowSize& size) :
world(size, Framebuffer::POSITION | Framebuffer::NORMAL | Framebuffer::COLOR | Framebuffer::RED | Framebuffer::DEPTH24_STENCIL8),
ssao(size, Framebuffer::RED),
ssaoBlur(size, Framebuffer::RED),
shadow(size, Framebuffer::DEPTH24_STENCIL8) {
}

void Framebuffers::resize(uint width, uint height) {
    world.resize(width, height);
    ssao.resize(width, height);
    ssaoBlur.resize(width, height);
    shadow.resize(width, height);
}

bool Framebuffers::hasError() const {
    return world.hasError() || ssao.hasError() || ssaoBlur.hasError() || shadow.hasError();
}