#include <cstring>

#include "common/utils/String.h"

String::String() : length(0) {
    data[0] = '\0';
}

String::String(const char* str) : length(0) {
    for(; length < MAX_LENGTH - 1 && str[length] != '\0'; length++) {
        data[length] = str[length];
    }
    data[length] = '\0';
}

bool String::operator==(const String& other) const {
    return length == other.length && strcmp(data, other.data) == 0;
}

bool String::operator!=(const String& other) const {
    return !(*this == other);
}

String::operator const char*() const {
    return data;
}

String& String::operator+=(char c) {
    if(length < MAX_LENGTH - 1) {
        data[length++] = c;
        data[length] = '\0';
    }
    return *this;
}

char String::operator[](uint index) const {
    return data[index];
}

uint String::getLength() const {
    return length;
}

